diff --git a/gcc/config/i386/i386.h b/gcc/config/i386/i386.h
index c5c1d58..4479bdc 100644
--- a/gcc/config/i386/i386.h
+++ b/gcc/config/i386/i386.h
@@ -142,7 +142,7 @@ see the files COPYING3 and COPYING.RUNTIME respectively.  If not, see
 
 /* SSE4.1 defines round instructions */
 #define	OPTION_MASK_ISA_ROUND	OPTION_MASK_ISA_SSE4_1
-#define	TARGET_ISA_ROUND	((ix86_isa_flags & OPTION_MASK_ISA_ROUND) != 0)
+#define	TARGET_ISA_ROUND	((GCC_OPTION (ix86_isa_flags) & OPTION_MASK_ISA_ROUND) != 0)
 
 #include "config/vxworks-dummy.h"
 
@@ -484,14 +484,14 @@ extern unsigned char ix86_arch_features[X86_ARCH_LAST];
 extern unsigned char x86_prefetch_sse;
 #define TARGET_PREFETCH_SSE	x86_prefetch_sse
 
-#define ASSEMBLER_DIALECT	(ix86_asm_dialect)
+#define ASSEMBLER_DIALECT	(GCC_OPTION (ix86_asm_dialect))
 
-#define TARGET_SSE_MATH		((ix86_fpmath & FPMATH_SSE) != 0)
+#define TARGET_SSE_MATH		((GCC_OPTION (ix86_fpmath) & FPMATH_SSE) != 0)
 #define TARGET_MIX_SSE_I387 \
- ((ix86_fpmath & (FPMATH_SSE | FPMATH_387)) == (FPMATH_SSE | FPMATH_387))
+ ((GCC_OPTION (ix86_fpmath) & (FPMATH_SSE | FPMATH_387)) == (FPMATH_SSE | FPMATH_387))
 
-#define TARGET_GNU_TLS		(ix86_tls_dialect == TLS_DIALECT_GNU)
-#define TARGET_GNU2_TLS		(ix86_tls_dialect == TLS_DIALECT_GNU2)
+#define TARGET_GNU_TLS		(GCC_OPTION (ix86_tls_dialect) == TLS_DIALECT_GNU)
+#define TARGET_GNU2_TLS		(GCC_OPTION (ix86_tls_dialect) == TLS_DIALECT_GNU2)
 #define TARGET_ANY_GNU_TLS	(TARGET_GNU_TLS || TARGET_GNU2_TLS)
 #define TARGET_SUN_TLS		0
 
@@ -502,8 +502,8 @@ extern unsigned char x86_prefetch_sse;
 #define TARGET_TLS_DIRECT_SEG_REFS_DEFAULT 0
 #endif
 
-#define TARGET_SSP_GLOBAL_GUARD (ix86_stack_protector_guard == SSP_GLOBAL)
-#define TARGET_SSP_TLS_GUARD    (ix86_stack_protector_guard == SSP_TLS)
+#define TARGET_SSP_GLOBAL_GUARD (GCC_OPTION (ix86_stack_protector_guard) == SSP_GLOBAL)
+#define TARGET_SSP_TLS_GUARD    (GCC_OPTION (ix86_stack_protector_guard) == SSP_TLS)
 
 /* Fence to use after loop using storent.  */
 
@@ -717,7 +717,7 @@ extern const char *host_detect_local_cpu (int argc, const char **argv);
 
 /* Boundary (in *bits*) on which stack pointer should be aligned.  */
 #define STACK_BOUNDARY \
- (TARGET_64BIT && ix86_abi == MS_ABI ? 128 : BITS_PER_WORD)
+ (TARGET_64BIT && GCC_OPTION (ix86_abi) == MS_ABI ? 128 : BITS_PER_WORD)
 
 /* Stack boundary of the main function guaranteed by OS.  */
 #define MAIN_STACK_BOUNDARY (TARGET_64BIT ? 128 : 32)
@@ -1215,9 +1215,9 @@ extern const char *host_detect_local_cpu (int argc, const char **argv);
 #define REAL_PIC_OFFSET_TABLE_REGNUM  BX_REG
 
 #define PIC_OFFSET_TABLE_REGNUM				\
-  ((TARGET_64BIT && (ix86_cmodel == CM_SMALL_PIC	\
+  ((TARGET_64BIT && (GCC_OPTION (ix86_cmodel) == CM_SMALL_PIC	\
                      || TARGET_PECOFF))		\
-   || !flag_pic ? INVALID_REGNUM			\
+   || !GCC_OPTION (flag_pic) ? INVALID_REGNUM			\
    : reload_completed ? REGNO (pic_offset_table_rtx)	\
    : REAL_PIC_OFFSET_TABLE_REGNUM)
 
@@ -1839,7 +1839,7 @@ do {									\
 /* Specify the machine mode that this machine uses
    for the index in the tablejump instruction.  */
 #define CASE_VECTOR_MODE \
- (!TARGET_LP64 || (flag_pic && ix86_cmodel != CM_LARGE_PIC) ? SImode : DImode)
+ (!TARGET_LP64 || (GCC_OPTION (flag_pic) && GCC_OPTION (ix86_cmodel) != CM_LARGE_PIC) ? SImode : DImode)
 
 /* Define this as 1 if `char' should by default be signed; else as 0.  */
 #define DEFAULT_SIGNED_CHAR 1
@@ -1897,7 +1897,7 @@ do {							\
 /* Specify the machine mode that pointers have.
    After generation of rtl, the compiler makes no further distinction
    between pointers and any other objects of this machine mode.  */
-#define Pmode (ix86_pmode == PMODE_DI ? DImode : SImode)
+#define Pmode (GCC_OPTION (ix86_pmode) == PMODE_DI ? DImode : SImode)
 
 /* A C expression whose value is zero if pointers that need to be extended
    from being `POINTER_SIZE' bits wide to `Pmode' are sign-extended and
@@ -1916,7 +1916,7 @@ do {							\
    is the default; other values are interpreted relative to that.  */
 
 #define BRANCH_COST(speed_p, predictable_p) \
-  (!(speed_p) ? 2 : (predictable_p) ? 0 : ix86_branch_cost)
+  (!(speed_p) ? 2 : (predictable_p) ? 0 : GCC_OPTION (ix86_branch_cost))
 
 /* An integer expression for the size in bits of the largest integer machine
    mode that should actually be used.  We allow pairs of registers.  */
@@ -2176,7 +2176,7 @@ do {									\
    sections.  This is the case for x86_64 on Mach-O for example.  */
 
 #define JUMP_TABLES_IN_TEXT_SECTION \
-  (flag_pic && ((TARGET_MACHO && TARGET_64BIT) \
+  (GCC_OPTION (flag_pic) && ((TARGET_MACHO && TARGET_64BIT) \
    || (!TARGET_64BIT && !HAVE_AS_GOTOFF_IN_DATA)))
 
 /* Switch to init or fini section via SECTION_OP, emit a call to FUNC,
@@ -2531,10 +2531,10 @@ extern void debug_dispatch_window (int);
 			 | RECIP_MASK_VEC_DIV | RECIP_MASK_VEC_SQRT)
 #define RECIP_MASK_DEFAULT (RECIP_MASK_VEC_DIV | RECIP_MASK_VEC_SQRT)
 
-#define TARGET_RECIP_DIV	((recip_mask & RECIP_MASK_DIV) != 0)
-#define TARGET_RECIP_SQRT	((recip_mask & RECIP_MASK_SQRT) != 0)
-#define TARGET_RECIP_VEC_DIV	((recip_mask & RECIP_MASK_VEC_DIV) != 0)
-#define TARGET_RECIP_VEC_SQRT	((recip_mask & RECIP_MASK_VEC_SQRT) != 0)
+#define TARGET_RECIP_DIV	((GCC_OPTION (recip_mask) & RECIP_MASK_DIV) != 0)
+#define TARGET_RECIP_SQRT	((GCC_OPTION (recip_mask) & RECIP_MASK_SQRT) != 0)
+#define TARGET_RECIP_VEC_DIV	((GCC_OPTION (recip_mask) & RECIP_MASK_VEC_DIV) != 0)
+#define TARGET_RECIP_VEC_SQRT	((GCC_OPTION (recip_mask) & RECIP_MASK_VEC_SQRT) != 0)
 
 #define IX86_HLE_ACQUIRE (1 << 16)
 #define IX86_HLE_RELEASE (1 << 17)
diff --git a/gcc/config/i386/mingw32.h b/gcc/config/i386/mingw32.h
index f563820..3b77832 100644
--- a/gcc/config/i386/mingw32.h
+++ b/gcc/config/i386/mingw32.h
@@ -44,7 +44,7 @@ along with GCC; see the file COPYING3.  If not see
       builtin_define_std ("WINNT");				\
       builtin_define_with_int_value ("_INTEGRAL_MAX_BITS",	\
 				     TYPE_PRECISION (intmax_type_node));\
-      if (TARGET_64BIT && ix86_abi == MS_ABI)			\
+      if (TARGET_64BIT && GCC_OPTION (ix86_abi) == MS_ABI)			\
 	{							\
 	  builtin_define ("__MINGW64__");			\
 	  builtin_define_std ("WIN64");				\
@@ -233,7 +233,7 @@ do {						         \
 
 #define HAVE_ENABLE_EXECUTE_STACK
 #undef  CHECK_EXECUTE_STACK_ENABLED
-#define CHECK_EXECUTE_STACK_ENABLED flag_setstackexecutable
+#define CHECK_EXECUTE_STACK_ENABLED GCC_OPTION (flag_setstackexecutable)
 
 /* This matches SHLIB_SONAME and SHLIB_SOVERSION in t-cygming. */
 /* This matches SHLIB_SONAME and SHLIB_SOVERSION in t-cygwin. */
diff --git a/gcc/config/i386/msformat-c.c b/gcc/config/i386/msformat-c.c
index 304d48f..09a478b 100644
--- a/gcc/config/i386/msformat-c.c
+++ b/gcc/config/i386/msformat-c.c
@@ -180,7 +180,7 @@ EXPORTED_CONST target_ovr_attr mingw_format_attribute_overrides[4] =
 extern void TARGET_OVERRIDES_FORMAT_INIT (void);
 
 /* Helper.  */
-#define C89_OR_EXT (warn_pedantic_ms_format ? STD_EXT : STD_C89)
+#define C89_OR_EXT (GCC_OPTION (warn_pedantic_ms_format) ? STD_EXT : STD_C89)
 
 void
 TARGET_OVERRIDES_FORMAT_INIT (void)
diff --git a/gcc/config/i386/netbsd-elf.h b/gcc/config/i386/netbsd-elf.h
index e575b39..f9eff92 100644
--- a/gcc/config/i386/netbsd-elf.h
+++ b/gcc/config/i386/netbsd-elf.h
@@ -78,7 +78,7 @@ along with GCC; see the file COPYING3.  If not see
 #undef FUNCTION_PROFILER
 #define FUNCTION_PROFILER(FILE, LABELNO)				\
 {									\
-  if (flag_pic)								\
+  if (GCC_OPTION (flag_pic))								\
     fprintf (FILE, "\tcall __mcount@PLT\n");				\
   else									\
     fprintf (FILE, "\tcall __mcount\n");				\
diff --git a/gcc/config/i386/netbsd64.h b/gcc/config/i386/netbsd64.h
index f990835..0601ea8 100644
--- a/gcc/config/i386/netbsd64.h
+++ b/gcc/config/i386/netbsd64.h
@@ -58,9 +58,9 @@ along with GCC; see the file COPYING3.  If not see
 #undef FUNCTION_PROFILER
 #define FUNCTION_PROFILER(FILE, LABELNO)				\
 {									\
-  if (TARGET_64BIT && flag_pic)						\
+  if (TARGET_64BIT && GCC_OPTION (flag_pic))						\
     fprintf (FILE, "\tcall *__mcount@PLT\n");				\
-  else if (flag_pic)							\
+  else if (GCC_OPTION (flag_pic))							\
     fprintf (FILE, "\tcall *__mcount@PLT\n");				\
   else									\
     fprintf (FILE, "\tcall __mcount\n");				\
diff --git a/gcc/config/i386/openbsd.h b/gcc/config/i386/openbsd.h
index f313d5c..495e562 100644
--- a/gcc/config/i386/openbsd.h
+++ b/gcc/config/i386/openbsd.h
@@ -82,7 +82,7 @@ along with GCC; see the file COPYING3.  If not see
    The icky part is not here, but in machine/profile.h.  */
 #undef FUNCTION_PROFILER
 #define FUNCTION_PROFILER(FILE, LABELNO)  \
-  fputs (flag_pic ? "\tcall mcount@PLT\n": "\tcall mcount\n", FILE);
+  fputs (GCC_OPTION (flag_pic) ? "\tcall mcount@PLT\n": "\tcall mcount\n", FILE);
 
 /* Assembler format: exception region output.  */
 
diff --git a/gcc/config/i386/openbsdelf.h b/gcc/config/i386/openbsdelf.h
index 46ae0b6..a123ed3 100644
--- a/gcc/config/i386/openbsdelf.h
+++ b/gcc/config/i386/openbsdelf.h
@@ -89,7 +89,7 @@ along with GCC; see the file COPYING3.  If not see
    The icky part is not here, but in <machine/profile.h>.  */
 #undef FUNCTION_PROFILER
 #define FUNCTION_PROFILER(FILE, LABELNO)  \
-  fputs (flag_pic ? "\tcall __mcount@PLT\n": "\tcall __mcount\n", FILE);
+  fputs (GCC_OPTION (flag_pic) ? "\tcall __mcount@PLT\n": "\tcall __mcount\n", FILE);
 
 #undef LINK_SPEC
 #define LINK_SPEC \
diff --git a/gcc/config/i386/sol2.h b/gcc/config/i386/sol2.h
index 8a21a59..1d11b265 100644
--- a/gcc/config/i386/sol2.h
+++ b/gcc/config/i386/sol2.h
@@ -29,7 +29,7 @@ along with GCC; see the file COPYING3.  If not see
    labels in different sections, so force DW_EH_PE_datarel.  */
 #undef ASM_PREFERRED_EH_DATA_FORMAT
 #define ASM_PREFERRED_EH_DATA_FORMAT(CODE,GLOBAL)			\
-  (flag_pic ? ((GLOBAL ? DW_EH_PE_indirect : 0)				\
+  (GCC_OPTION (flag_pic) ? ((GLOBAL ? DW_EH_PE_indirect : 0)				\
 	       | (TARGET_64BIT ? DW_EH_PE_pcrel | DW_EH_PE_sdata4	\
 		  : DW_EH_PE_datarel))					\
    : DW_EH_PE_absptr)
@@ -133,7 +133,7 @@ along with GCC; see the file COPYING3.  If not see
 	ASM_OUTPUT_TYPE_DIRECTIVE (FILE, NAME, "object");	\
 								\
       size_directive_output = 0;				\
-      if (!flag_inhibit_size_directive				\
+      if (!GCC_OPTION (flag_inhibit_size_directive)				\
 	  && (DECL) && DECL_SIZE (DECL))			\
 	{							\
 	  size_directive_output = 1;				\
diff --git a/gcc/config/i386/winnt-cxx.c b/gcc/config/i386/winnt-cxx.c
index aa75f91..bb7287e 100644
--- a/gcc/config/i386/winnt-cxx.c
+++ b/gcc/config/i386/winnt-cxx.c
@@ -37,7 +37,7 @@ i386_pe_type_dllimport_p (tree decl)
   gcc_assert (TREE_CODE (decl) == VAR_DECL 
 	      || TREE_CODE (decl) == FUNCTION_DECL);
 
-  if (TARGET_NOP_FUN_DLLIMPORT && TREE_CODE (decl) == FUNCTION_DECL)
+  if (GCC_OPTION (TARGET_NOP_FUN_DLLIMPORT) && TREE_CODE (decl) == FUNCTION_DECL)
     return false;
 
   /* We ignore the dllimport attribute for inline member functions.
@@ -71,7 +71,7 @@ i386_pe_type_dllexport_p (tree decl)
       && DECL_DECLARED_INLINE_P (decl))
     {
       if (DECL_REALLY_EXTERN (decl)
-	  || !flag_keep_inline_dllexport)
+	  || !GCC_OPTION (flag_keep_inline_dllexport))
 	return false;
     }
   return true;
diff --git a/gcc/config/i386/winnt.c b/gcc/config/i386/winnt.c
index bcfd48a..0836073 100644
--- a/gcc/config/i386/winnt.c
+++ b/gcc/config/i386/winnt.c
@@ -125,7 +125,7 @@ i386_pe_determine_dllexport_p (tree decl)
 
   if (TREE_CODE (decl) == FUNCTION_DECL
       && DECL_DECLARED_INLINE_P (decl)
-      && !flag_keep_inline_dllexport)
+      && !GCC_OPTION (flag_keep_inline_dllexport))
     return false; 
 
   if (lookup_attribute ("dllexport", DECL_ATTRIBUTES (decl)))
@@ -170,7 +170,7 @@ i386_pe_determine_dllimport_p (tree decl)
 bool
 i386_pe_valid_dllimport_attribute_p (const_tree decl)
 {
-   if (TARGET_NOP_FUN_DLLIMPORT && TREE_CODE (decl) == FUNCTION_DECL)
+   if (GCC_OPTION (TARGET_NOP_FUN_DLLIMPORT) && TREE_CODE (decl) == FUNCTION_DECL)
      return false;
    return true;
 }
@@ -415,7 +415,7 @@ i386_pe_unique_section (tree decl, int reloc)
 
   /* Ignore RELOC, if we are allowed to put relocated
      const data into read-only section.  */
-  if (!flag_writable_rel_rdata)
+  if (!GCC_OPTION (flag_writable_rel_rdata))
     reloc = 0;
   name = IDENTIFIER_POINTER (DECL_ASSEMBLER_NAME (decl));
   name = i386_pe_strip_name_encoding_full (name);
@@ -473,7 +473,7 @@ i386_pe_section_type_flags (tree decl, const char *name, int reloc)
 
   /* Ignore RELOC, if we are allowed to put relocated
      const data into read-only section.  */
-  if (!flag_writable_rel_rdata)
+  if (!GCC_OPTION (flag_writable_rel_rdata))
     reloc = 0;
   /* The names we put in the hashtable will always be the unique
      versions given to us by the stringtable, so we can just use
@@ -596,7 +596,7 @@ i386_pe_asm_output_aligned_decl_common (FILE *stream, tree decl,
 
   fprintf (stream, "\t.comm\t");
   assemble_name (stream, name);
-  if (use_pe_aligned_common)
+  if (GCC_OPTION (use_pe_aligned_common))
     fprintf (stream, ", " HOST_WIDE_INT_PRINT_DEC ", %d\n",
 	   size ? size : (HOST_WIDE_INT) 1,
 	   exact_log2 (align) - exact_log2 (CHAR_BIT));
@@ -1285,7 +1285,7 @@ void
 i386_pe_start_function (FILE *f, const char *name, tree decl)
 {
   i386_pe_maybe_record_exported_symbol (decl, name, 0);
-  if (write_symbols != SDB_DEBUG)
+  if (GCC_OPTION (write_symbols) != SDB_DEBUG)
     i386_pe_declare_function_type (f, name, TREE_PUBLIC (decl));
   /* In case section was altered by debugging output.  */
   if (decl != NULL_TREE)
diff --git a/gcc/config/ia64/ia64.c b/gcc/config/ia64/ia64.c
index 41adc4a..45906d3 100644
--- a/gcc/config/ia64/ia64.c
+++ b/gcc/config/ia64/ia64.c
@@ -2662,7 +2662,7 @@ ia64_compute_frame_size (HOST_WIDE_INT size)
     mark_reg_gr_used_mask (cfun->machine->ia64_eh_epilogue_bsp, NULL);
 
   /* Static stack checking uses r2 and r3.  */
-  if (flag_stack_check == STATIC_BUILTIN_STACK_CHECK)
+  if (GCC_OPTION (flag_stack_check) == STATIC_BUILTIN_STACK_CHECK)
     current_frame_info.gr_used_mask |= 0xc;
 
   /* Find the size of the register stack frame.  We have only 80 local
@@ -3455,10 +3455,10 @@ ia64_expand_prologue (void)
   ia64_compute_frame_size (get_frame_size ());
   last_scratch_gr_reg = 15;
 
-  if (flag_stack_usage_info)
+  if (GCC_OPTION (flag_stack_usage_info))
     current_function_static_stack_size = current_frame_info.total_size;
 
-  if (flag_stack_check == STATIC_BUILTIN_STACK_CHECK)
+  if (GCC_OPTION (flag_stack_check) == STATIC_BUILTIN_STACK_CHECK)
     {
       HOST_WIDE_INT size = current_frame_info.total_size;
       int bs_size = BACKING_STORE_SIZE (current_frame_info.n_input_regs
@@ -3496,7 +3496,7 @@ ia64_expand_prologue (void)
   /* If there is no epilogue, then we don't need some prologue insns.
      We need to avoid emitting the dead prologue insns, because flow
      will complain about them.  */
-  if (optimize)
+  if (GCC_OPTION (optimize))
     {
       edge e;
       edge_iterator ei;
@@ -5967,7 +5967,7 @@ ia64_option_override (void)
   unsigned int i;
   cl_deferred_option *opt;
   vec<cl_deferred_option> *v
-    = (vec<cl_deferred_option> *) ia64_deferred_options;
+    = (vec<cl_deferred_option> *) GCC_OPTION (ia64_deferred_options);
 
   if (v)
     FOR_EACH_VEC_ELT (*v, i, opt)
@@ -5984,28 +5984,28 @@ ia64_option_override (void)
       }
 
   if (TARGET_AUTO_PIC)
-    target_flags |= MASK_CONST_GP;
+    GCC_OPTION (target_flags) |= MASK_CONST_GP;
 
   /* Numerous experiment shows that IRA based loop pressure
      calculation works better for RTL loop invariant motion on targets
      with enough (>= 32) registers.  It is an expensive optimization.
      So it is on only for peak performance.  */
-  if (optimize >= 3)
-    flag_ira_loop_pressure = 1;
+  if (GCC_OPTION (optimize) >= 3)
+    GCC_OPTION (flag_ira_loop_pressure) = 1;
 
 
   ia64_section_threshold = (global_options_set.x_g_switch_value
-			    ? g_switch_value
+			    ? GCC_OPTION (g_switch_value)
 			    : IA64_DEFAULT_GVALUE);
 
   init_machine_status = ia64_init_machine_status;
 
-  if (align_functions <= 0)
-    align_functions = 64;
-  if (align_loops <= 0)
-    align_loops = 32;
+  if (GCC_OPTION (align_functions) <= 0)
+    GCC_OPTION (align_functions) = 64;
+  if (GCC_OPTION (align_loops) <= 0)
+    GCC_OPTION (align_loops) = 32;
   if (TARGET_ABI_OPEN_VMS)
-    flag_no_common = 1;
+    GCC_OPTION (flag_no_common) = 1;
 
   ia64_override_options_after_change();
 }
@@ -6015,24 +6015,24 @@ ia64_option_override (void)
 static void
 ia64_override_options_after_change (void)
 {
-  if (optimize >= 3
+  if (GCC_OPTION (optimize) >= 3
       && !global_options_set.x_flag_selective_scheduling
       && !global_options_set.x_flag_selective_scheduling2)
     {
-      flag_selective_scheduling2 = 1;
-      flag_sel_sched_pipelining = 1;
+      GCC_OPTION (flag_selective_scheduling2) = 1;
+      GCC_OPTION (flag_sel_sched_pipelining) = 1;
     }
-  if (mflag_sched_control_spec == 2)
+  if (GCC_OPTION (mflag_sched_control_spec) == 2)
     {
       /* Control speculation is on by default for the selective scheduler,
          but not for the Haifa scheduler.  */
-      mflag_sched_control_spec = flag_selective_scheduling2 ? 1 : 0;
+      GCC_OPTION (mflag_sched_control_spec) = GCC_OPTION (flag_selective_scheduling2) ? 1 : 0;
     }
-  if (flag_sel_sched_pipelining && flag_auto_inc_dec)
+  if (GCC_OPTION (flag_sel_sched_pipelining) && GCC_OPTION (flag_auto_inc_dec))
     {
       /* FIXME: remove this when we'd implement breaking autoinsns as
          a transformation.  */
-      flag_auto_inc_dec = 0;
+      GCC_OPTION (flag_auto_inc_dec) = 0;
     }
 }
 
@@ -7199,7 +7199,7 @@ ia64_adjust_cost_2 (rtx insn, int dep_type1, rtx dep_insn, int cost, dw_t dw)
   else if (dw > MIN_DEP_WEAK)
     {
       /* Store and load are less likely to alias.  */
-      if (mflag_sched_fp_mem_deps_zero_cost && dep_class == ITANIUM_CLASS_STF)
+      if (GCC_OPTION (mflag_sched_fp_mem_deps_zero_cost) && dep_class == ITANIUM_CLASS_STF)
 	/* Assume there will be no cache conflict for floating-point data.
 	   For integer data, L1 conflict penalty is huge (17 cycles), so we
 	   never assume it will not cause a conflict.  */
@@ -7446,7 +7446,7 @@ ia64_dfa_sched_reorder (FILE *dump, int sched_verbose, rtx *ready,
     }
 
   current_cycle = clock_var;
-  if (reload_completed && mem_ops_in_group[clock_var % 4] >= ia64_max_memory_insns)
+  if (reload_completed && mem_ops_in_group[clock_var % 4] >= GCC_OPTION (ia64_max_memory_insns))
     {
       int moved = 0;
 
@@ -7541,9 +7541,9 @@ ia64_first_cycle_multipass_dfa_lookahead_guard (rtx insn)
   return ((!reload_completed
 	   || !safe_group_barrier_needed (insn))
 	  && ia64_first_cycle_multipass_dfa_lookahead_guard_spec (insn)
-	  && (!mflag_sched_mem_insns_hard_limit
+	  && (!GCC_OPTION (mflag_sched_mem_insns_hard_limit)
 	      || !is_load_p (insn)
-	      || mem_ops_in_group[current_cycle % 4] < ia64_max_memory_insns));
+	      || mem_ops_in_group[current_cycle % 4] < GCC_OPTION (ia64_max_memory_insns)));
 }
 
 /* We are choosing insn from the ready queue.  Return nonzero if INSN
@@ -7605,7 +7605,7 @@ ia64_dfa_new_cycle (FILE *dump, int verbose, rtx insn, int last_clock,
 
   if ((reload_completed
        && (safe_group_barrier_needed (insn)
-	   || (mflag_sched_stop_bits_after_every_cycle
+	   || (GCC_OPTION (mflag_sched_stop_bits_after_every_cycle)
 	       && last_clock != clock
 	       && last_scheduled_insn
 	       && scheduled_good_insn (last_scheduled_insn))))
@@ -7911,24 +7911,24 @@ ia64_set_sched_flags (spec_info_t spec_info)
     {
       int mask = 0;
 
-      if ((mflag_sched_br_data_spec && !reload_completed && optimize > 0)
-          || (mflag_sched_ar_data_spec && reload_completed))
+      if ((GCC_OPTION (mflag_sched_br_data_spec) && !reload_completed && GCC_OPTION (optimize) > 0)
+          || (GCC_OPTION (mflag_sched_ar_data_spec) && reload_completed))
 	{
 	  mask |= BEGIN_DATA;
 
 	  if (!sel_sched_p ()
-	      && ((mflag_sched_br_in_data_spec && !reload_completed)
-		  || (mflag_sched_ar_in_data_spec && reload_completed)))
+	      && ((GCC_OPTION (mflag_sched_br_in_data_spec) && !reload_completed)
+		  || (GCC_OPTION (mflag_sched_ar_in_data_spec) && reload_completed)))
 	    mask |= BE_IN_DATA;
 	}
       
-      if (mflag_sched_control_spec
+      if (GCC_OPTION (mflag_sched_control_spec)
           && (!sel_sched_p ()
 	      || reload_completed))
 	{
 	  mask |= BEGIN_CONTROL;
 	  
-	  if (!sel_sched_p () && mflag_sched_in_control_spec)
+	  if (!sel_sched_p () && GCC_OPTION (mflag_sched_in_control_spec))
 	    mask |= BE_IN_CONTROL;
 	}
 
@@ -7943,15 +7943,15 @@ ia64_set_sched_flags (spec_info_t spec_info)
 	  
 	  spec_info->flags = 0;
       
-	  if ((mask & DATA_SPEC) && mflag_sched_prefer_non_data_spec_insns)
+	  if ((mask & DATA_SPEC) && GCC_OPTION (mflag_sched_prefer_non_data_spec_insns))
 	    spec_info->flags |= PREFER_NON_DATA_SPEC;
 
 	  if (mask & CONTROL_SPEC)
 	    {
-	      if (mflag_sched_prefer_non_control_spec_insns)
+	      if (GCC_OPTION (mflag_sched_prefer_non_control_spec_insns))
 		spec_info->flags |= PREFER_NON_CONTROL_SPEC;
 
-	      if (sel_sched_p () && mflag_sel_sched_dont_check_control_spec)
+	      if (sel_sched_p () && GCC_OPTION (mflag_sel_sched_dont_check_control_spec))
 		spec_info->flags |= SEL_SCHED_SPEC_DONT_CHECK_CONTROL;
 	    }
 
@@ -7960,7 +7960,7 @@ ia64_set_sched_flags (spec_info_t spec_info)
 	  else
 	    spec_info->dump = 0;
 	  
-	  if (mflag_sched_count_spec_in_critical_path)
+	  if (GCC_OPTION (mflag_sched_count_spec_in_critical_path))
 	    spec_info->flags |= COUNT_SPEC_IN_CRITICAL_PATH;
 	}
     }
@@ -8326,7 +8326,7 @@ get_spec_check_gen_function (ds_t ts, int mode_no,
 
       if (simple_check_p)
 	{
-	  gcc_assert (mflag_sched_spec_ldc);
+	  gcc_assert (GCC_OPTION (mflag_sched_spec_ldc));
 
 	  if (clearing_check_p)
 	    gen_check = gen_ld_c_clr;
@@ -8371,11 +8371,11 @@ static bool
 ia64_needs_block_p (ds_t ts)
 {
   if (ts & BEGIN_DATA)
-    return !mflag_sched_spec_ldc;
+    return !GCC_OPTION (mflag_sched_spec_ldc);
 
   gcc_assert ((ts & BEGIN_CONTROL) != 0);
 
-  return !(mflag_sched_spec_control_ldc && mflag_sched_spec_ldc);
+  return !(GCC_OPTION (mflag_sched_spec_control_ldc) && GCC_OPTION (mflag_sched_spec_ldc));
 }
 
 /* Generate (or regenerate) a recovery check for INSN.  */
@@ -9427,7 +9427,7 @@ final_emit_insn_group_barriers (FILE *dump ATTRIBUTE_UNUSED)
 	      need_barrier_p = 0;
 	    }
 	  else if (need_barrier_p || group_barrier_needed (insn)
-		   || (mflag_sched_stop_bits_after_every_cycle
+		   || (GCC_OPTION (mflag_sched_stop_bits_after_every_cycle)
 		       && GET_MODE (insn) == TImode
 		       && seen_good_insn))
 	    {
@@ -9676,10 +9676,10 @@ ia64_reorg (void)
   compute_bb_for_insn ();
 
   /* If optimizing, we'll have split before scheduling.  */
-  if (optimize == 0)
+  if (GCC_OPTION (optimize) == 0)
     split_all_insns ();
 
-  if (optimize && flag_schedule_insns_after_reload
+  if (GCC_OPTION (optimize) && GCC_OPTION (flag_schedule_insns_after_reload)
       && dbg_cnt (ia64_sched2))
     {
       basic_block bb;
@@ -9698,7 +9698,7 @@ ia64_reorg (void)
       clocks_length = get_max_uid () + 1;
       stops_p = XCNEWVEC (char, clocks_length);
 
-      if (ia64_tune == PROCESSOR_ITANIUM2)
+      if (GCC_OPTION (ia64_tune) == PROCESSOR_ITANIUM2)
 	{
 	  pos_1 = get_cpu_unit_code ("2_1");
 	  pos_2 = get_cpu_unit_code ("2_2");
@@ -9757,7 +9757,7 @@ ia64_reorg (void)
 	  _1mlx_ = get_cpu_unit_code ("1b_1mlx.");
 	}
 
-      if (flag_selective_scheduling2
+      if (GCC_OPTION (flag_selective_scheduling2)
 	  && !maybe_skip_selective_scheduling ())
         run_selective_scheduling ();
       else
@@ -9815,7 +9815,7 @@ ia64_reorg (void)
 
   emit_predicate_relation_info ();
 
-  if (flag_var_tracking)
+  if (GCC_OPTION (flag_var_tracking))
     {
       timevar_push (TV_VAR_TRACKING);
       variable_tracking_main ();
@@ -10686,7 +10686,7 @@ ia64_hpux_reloc_rw_mask (void)
 static int
 ia64_reloc_rw_mask (void)
 {
-  return flag_pic ? 3 : 2;
+  return GCC_OPTION (flag_pic) ? 3 : 2;
 }
 
 /* Return the section to use for X.  The only special thing we do here
diff --git a/gcc/config/ia64/ia64.h b/gcc/config/ia64/ia64.h
index dd14b8a..1b6ed50 100644
--- a/gcc/config/ia64/ia64.h
+++ b/gcc/config/ia64/ia64.h
@@ -65,9 +65,9 @@ extern unsigned int ia64_section_threshold;
 #define TARGET_HAVE_TLS true
 #endif
 
-#define TARGET_TLS14		(ia64_tls_size == 14)
-#define TARGET_TLS22		(ia64_tls_size == 22)
-#define TARGET_TLS64		(ia64_tls_size == 64)
+#define TARGET_TLS14		(GCC_OPTION (ia64_tls_size) == 14)
+#define TARGET_TLS22		(GCC_OPTION (ia64_tls_size) == 22)
+#define TARGET_TLS64		(GCC_OPTION (ia64_tls_size) == 64)
 
 #define TARGET_HPUX		0
 #define TARGET_HPUX_LD		0
diff --git a/gcc/config/iq2000/iq2000.c b/gcc/config/iq2000/iq2000.c
index ed7aecb..a726dbb 100644
--- a/gcc/config/iq2000/iq2000.c
+++ b/gcc/config/iq2000/iq2000.c
@@ -1094,7 +1094,7 @@ init_cumulative_args (CUMULATIVE_ARGS *cum, tree fntype,
   tree param;
   tree next_param;
 
-  if (TARGET_DEBUG_D_MODE)
+  if (GCC_OPTION (TARGET_DEBUG_D_MODE))
     {
       fprintf (stderr,
 	       "\ninit_cumulative_args, fntype = 0x%.8lx", (long) fntype);
@@ -1137,7 +1137,7 @@ iq2000_function_arg_advance (cumulative_args_t cum_v, enum machine_mode mode,
 {
   CUMULATIVE_ARGS *cum = get_cumulative_args (cum_v);
 
-  if (TARGET_DEBUG_D_MODE)
+  if (GCC_OPTION (TARGET_DEBUG_D_MODE))
     {
       fprintf (stderr,
 	       "function_adv({gp reg found = %d, arg # = %2d, words = %2d}, %4s, ",
@@ -1216,7 +1216,7 @@ iq2000_function_arg (cumulative_args_t cum_v, enum machine_mode mode,
 		      || TREE_CODE (type) == UNION_TYPE
 		      || TREE_CODE (type) == QUAL_UNION_TYPE));
 
-  if (TARGET_DEBUG_D_MODE)
+  if (GCC_OPTION (TARGET_DEBUG_D_MODE))
     {
       fprintf (stderr,
 	       "function_arg( {gp reg found = %d, arg # = %2d, words = %2d}, %4s, ",
@@ -1271,7 +1271,7 @@ iq2000_function_arg (cumulative_args_t cum_v, enum machine_mode mode,
 
   if (*arg_words >= (unsigned) MAX_ARGS_IN_REGISTERS)
     {
-      if (TARGET_DEBUG_D_MODE)
+      if (GCC_OPTION (TARGET_DEBUG_D_MODE))
 	fprintf (stderr, "<stack>%s\n", struct_p ? ", [struct]" : "");
 
       ret = 0;
@@ -1348,7 +1348,7 @@ iq2000_function_arg (cumulative_args_t cum_v, enum machine_mode mode,
 	    }
 	}
 
-      if (TARGET_DEBUG_D_MODE)
+      if (GCC_OPTION (TARGET_DEBUG_D_MODE))
 	fprintf (stderr, "%s%s\n", reg_names[regbase + *arg_words + bias],
 		 struct_p ? ", [struct]" : "");
     }
@@ -1388,7 +1388,7 @@ iq2000_arg_partial_bytes (cumulative_args_t cum_v, enum machine_mode mode,
 
   if (mode == DImode && cum->arg_words == MAX_ARGS_IN_REGISTERS - 1)
     {
-      if (TARGET_DEBUG_D_MODE)
+      if (GCC_OPTION (TARGET_DEBUG_D_MODE))
 	fprintf (stderr, "iq2000_arg_partial_bytes=%d\n", UNITS_PER_WORD);
       return UNITS_PER_WORD;
     }
@@ -1432,7 +1432,7 @@ iq2000_init_machine_status (void)
 static void
 iq2000_option_override (void)
 {
-  target_flags &= ~MASK_GPOPT;
+  GCC_OPTION (target_flags) &= ~MASK_GPOPT;
 
   iq2000_isa = IQ2000_ISA_DEFAULT;
 
@@ -1659,7 +1659,7 @@ compute_frame_size (HOST_WIDE_INT size)
   /* The gp reg is caller saved, so there is no need for leaf routines 
      (total_size == extra_size) to save the gp reg.  */
   if (total_size == extra_size
-      && ! profile_flag)
+      && ! GCC_OPTION (profile_flag))
     total_size = extra_size = 0;
 
   total_size += IQ2000_STACK_ALIGN (crtl->args.pretend_args_size);
@@ -2138,7 +2138,7 @@ iq2000_can_use_return_insn (void)
   if (! reload_completed)
     return 0;
 
-  if (df_regs_ever_live_p (31) || profile_flag)
+  if (df_regs_ever_live_p (31) || GCC_OPTION (profile_flag))
     return 0;
 
   if (cfun->machine->initialized)
@@ -2170,7 +2170,7 @@ static section *
 iq2000_select_section (tree decl, int reloc ATTRIBUTE_UNUSED,
 		       unsigned HOST_WIDE_INT align ATTRIBUTE_UNUSED)
 {
-  if (TARGET_EMBEDDED_DATA)
+  if (GCC_OPTION (TARGET_EMBEDDED_DATA))
     {
       /* For embedded applications, always put an object in read-only data
 	 if possible, in order to reduce RAM usage.  */
diff --git a/gcc/config/iq2000/iq2000.h b/gcc/config/iq2000/iq2000.h
index 602898a..7495981 100644
--- a/gcc/config/iq2000/iq2000.h
+++ b/gcc/config/iq2000/iq2000.h
@@ -580,7 +580,7 @@ enum delay_type
 };
 
 /* Recast the cpu class to be the cpu attribute.  */
-#define iq2000_cpu_attr ((enum attr_cpu) iq2000_tune)
+#define iq2000_cpu_attr ((enum attr_cpu) GCC_OPTION (iq2000_tune))
 
 #define BITMASK_UPPER16	((unsigned long) 0xffff << 16)	/* 0xffff0000 */
 #define BITMASK_LOWER16	((unsigned long) 0xffff)	/* 0x0000ffff */
diff --git a/gcc/config/linux.h b/gcc/config/linux.h
index d38ef81..a551067 100644
--- a/gcc/config/linux.h
+++ b/gcc/config/linux.h
@@ -33,9 +33,9 @@ see the files COPYING3 and COPYING.RUNTIME respectively.  If not, see
 #define OPTION_UCLIBC (DEFAULT_LIBC == LIBC_UCLIBC)
 #define OPTION_BIONIC (DEFAULT_LIBC == LIBC_BIONIC)
 #else
-#define OPTION_GLIBC  (linux_libc == LIBC_GLIBC)
-#define OPTION_UCLIBC (linux_libc == LIBC_UCLIBC)
-#define OPTION_BIONIC (linux_libc == LIBC_BIONIC)
+#define OPTION_GLIBC  (GCC_OPTION (linux_libc) == LIBC_GLIBC)
+#define OPTION_UCLIBC (GCC_OPTION (linux_libc) == LIBC_UCLIBC)
+#define OPTION_BIONIC (GCC_OPTION (linux_libc) == LIBC_BIONIC)
 #endif
 
 #define GNU_USER_TARGET_OS_CPP_BUILTINS()			\
diff --git a/gcc/config/lm32/lm32.c b/gcc/config/lm32/lm32.c
index 4f6aba1..2dee6c9 100644
--- a/gcc/config/lm32/lm32.c
+++ b/gcc/config/lm32/lm32.c
@@ -456,7 +456,7 @@ lm32_compute_frame_size (int size)
 	}
     }
   if (df_regs_ever_live_p (RA_REGNUM) || ! crtl->is_leaf
-      || !optimize)
+      || !GCC_OPTION (optimize))
     {
       reg_save_mask |= 1 << RA_REGNUM;
       callee_size += UNITS_PER_WORD;
@@ -724,7 +724,7 @@ lm32_option_override (void)
 {
   /* We must have sign-extend enabled if barrel-shift isn't.  */
   if (!TARGET_BARREL_SHIFT_ENABLED && !TARGET_SIGN_EXTEND_ENABLED)
-    target_flags |= MASK_SIGN_EXTEND_ENABLED;
+    GCC_OPTION (target_flags) |= MASK_SIGN_EXTEND_ENABLED;
 }
 
 /* Return nonzero if this function is known to have a null epilogue.
@@ -763,7 +763,7 @@ lm32_return_addr_rtx (int count, rtx frame)
 	  set_mem_alias_set (r, get_frame_alias_set ());
 	}
     }
-  else if (flag_omit_frame_pointer)
+  else if (GCC_OPTION (flag_omit_frame_pointer))
     r = NULL_RTX;
   else
     {
@@ -800,7 +800,7 @@ lm32_in_small_data_p (const_tree exp)
 
       /* If this is an incomplete type with size 0, then we can't put it
          in sdata because it might be too big when completed.  */
-      if (size > 0 && size <= g_switch_value)
+      if (size > 0 && size <= GCC_OPTION (g_switch_value))
 	return true;
     }
 
@@ -1152,7 +1152,7 @@ lm32_rtx_costs (rtx x, int code, int outer_code, int opno ATTRIBUTE_UNUSED,
 
 	case MEM:
 	case SET:
-	  if (g_switch_value)
+	  if (GCC_OPTION (g_switch_value))
 	    {
 	      *total = COSTS_N_INSNS (0);
 	      return true;
